Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# CharacterJoint Class Reference

This represents one joint of the character's animation, containing an animating transform matrix. More...

Inheritance diagram for CharacterJoint:

List of all members.

## Public Member Functions
| CharacterJoint (Character character, PartBundle root, PartGroup parent, string name, Mat4 const default_value)
bool | addLocalTransform (PandaNode node)
| Adds the indicated node to the list of nodes that will be updated each frame with the joint's local transform from its parent.
bool | addNetTransform (PandaNode node)
| Adds the indicated node to the list of nodes that will be updated each frame with the joint's net transform from the root.
| clearLocalTransforms ()
| Removes all nodes from the list of nodes that will be updated each frame with the joint's local transform from its parent.
| clearNetTransforms ()
| Removes all nodes from the list of nodes that will be updated each frame with the joint's net transform from the root.
Character | getCharacter ()
| Returns the Character that owns this joint.
NodePathCollection | getLocalTransforms ()
| Returns a list of the local transforms set for this node.
| getNetTransform (Mat4 transform)
| Copies the joint's current net transform (composed from the root of the character joint hierarchy) into the indicated matrix.
NodePathCollection | getNetTransforms ()
| Returns a list of the net transforms set for this node.
| getTransform (Mat4 transform)
| Copies the joint's current transform into the indicated matrix.
Mat4 const | getTransform ()
| Returns the transform matrix of the joint.
TransformState const | getTransformState ()
bool | hasLocalTransform (PandaNode node)
| Returns true if the node is on the list of nodes that will be updated each frame with the joint's local transform from its parent, false otherwise.
bool | hasNetTransform (PandaNode node)
| Returns true if the node is on the list of nodes that will be updated each frame with the joint's net transform from the root, false otherwise.
bool | removeLocalTransform (PandaNode node)
| Removes the indicated node from the list of nodes that will be updated each frame with the joint's local transform from its parent.
bool | removeNetTransform (PandaNode node)
| Removes the indicated node from the list of nodes that will be updated each frame with the joint's net transform from the root.
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

This represents one joint of the character's animation, containing an animating transform matrix.

## Constructor & Destructor Documentation

CharacterJoint | ( | Character | character,
|  | PartBundle | root,
|  | PartGroup | parent,
|  | string | name,
|  | Mat4 const | default_value
| ) |  |

## Member Function Documentation

bool addLocalTransform | ( | PandaNode | node | ) |

Adds the indicated node to the list of nodes that will be updated each frame with the joint's local transform from its parent.

Returns true if the node is successfully added, false if it had already been added.

The Character pointer should be the Character object that owns this joint; this will be used to create a CharacterJointEffect for this node. If it is NULL, no such effect will be created.

A CharacterJointEffect for this joint's Character will automatically be added to the specified node.

bool addNetTransform | ( | PandaNode | node | ) |

Adds the indicated node to the list of nodes that will be updated each frame with the joint's net transform from the root.

Returns true if the node is successfully added, false if it had already been added.

A CharacterJointEffect for this joint's Character will automatically be added to the specified node.

clearLocalTransforms | ( |  | ) |

Removes all nodes from the list of nodes that will be updated each frame with the joint's local transform from its parent.

clearNetTransforms | ( |  | ) |

Removes all nodes from the list of nodes that will be updated each frame with the joint's net transform from the root.

Character getCharacter | ( |  | ) |

Returns the Character that owns this joint.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from MovingPartMatrix.

NodePathCollection getLocalTransforms | ( |  | ) |

Returns a list of the local transforms set for this node.

Note that this returns a list of NodePaths, even though the local transforms are actually a list of PandaNodes.

getNetTransform | ( | Mat4 | transform | ) |

Copies the joint's current net transform (composed from the root of the character joint hierarchy) into the indicated matrix.

NodePathCollection getNetTransforms | ( |  | ) |

Returns a list of the net transforms set for this node.

Note that this returns a list of NodePaths, even though the net transforms are actually a list of PandaNodes.

Mat4 const getTransform | ( |  | ) |

Returns the transform matrix of the joint.

getTransform | ( | Mat4 | transform | ) |

Copies the joint's current transform into the indicated matrix.

TransformState const getTransformState | ( |  | ) |

bool hasLocalTransform | ( | PandaNode | node | ) |

Returns true if the node is on the list of nodes that will be updated each frame with the joint's local transform from its parent, false otherwise.

bool hasNetTransform | ( | PandaNode | node | ) |

Returns true if the node is on the list of nodes that will be updated each frame with the joint's net transform from the root, false otherwise.

bool removeLocalTransform | ( | PandaNode | node | ) |

Removes the indicated node from the list of nodes that will be updated each frame with the joint's local transform from its parent.

Returns true if the node is successfully removed, false if it was not on the list.

If the node has a CharacterJointEffect that matches this joint's Character, it will be cleared.

bool removeNetTransform | ( | PandaNode | node | ) |

Removes the indicated node from the list of nodes that will be updated each frame with the joint's net transform from the root.

Returns true if the node is successfully removed, false if it was not on the list.

If the node has a CharacterJointEffect that matches this joint's Character, it will be cleared.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties